col sql_feature   for a50;
col feature_path  for a75;
col class         for a30;
col name heading HINT for a30;
col inverse for a30;

with v as (
select f.sql_feature,f.description,f.property,h.parent_id
from v$sql_feature f
     join v$sql_feature_hierarchy h 
          on f.sql_feature = h.sql_feature
)
,feature_hierarchy as (
   select 
     level lvl
    ,sql_feature
    ,sys_connect_by_path(sql_feature,'/') feature_path
    ,description
    ,property
   from v
   start with parent_id is null
           and description not like 'Fix-%'
   connect by parent_id = prior sql_feature
           and not(sql_feature='QKSFM_CBQT' and parent_id='QKSFM_CBO')
)
select 
  rpad('.',(f.lvl-1)*2,'.')|| f.sql_feature as sql_feature
 ,replace(feature_path,'QKSFM_') feature_path
 ,h.class
 ,h.name
 ,h.inverse
 ,h.target_level
 ,h.property
 ,h.version
 ,h.version
 ,h.version_outline
from feature_hierarchy f
     join v$sql_hint h
          on h.sql_feature=f.sql_feature
where 1=1
and name not in (select inverse from v$sql_hint where inverse like 'NO%')
--and f.sql_feature 
--and name like 'MATERIALIZE'
order by 2,3
/
